package de.infa.plugins.bgloc.service;

import android.content.BroadcastReceiver;
import android.content.Intent;
import android.location.Location;
import android.os.Build;

import com.getcapacitor.JSObject;

public abstract class PluginReceiver extends BroadcastReceiver {
  public JSObject getLocationUpdateResponse(Intent intent) {
    int id = intent.getIntExtra(LocationService.INTENT_LOCATION_UPDATE_EXTRA_ID, -1);
    String session = intent.getStringExtra(LocationService.INTENT_LOCATION_UPDATE_EXTRA_SESSION);
    Location location = intent.getParcelableExtra(LocationService.INTENT_LOCATION_UPDATE_EXTRA_LOCATION);
    JSObject json = new JSObject();
    if (location != null) {
      json.put("id", id);
      json.put("sessionToken", session);
      json.put("time", location.getTime());
      json.put("latitude", location.getLatitude());
      json.put("longitude", location.getLongitude());
      json.put("altitude", location.getAltitude());
      json.put("speed", location.getSpeed());
      json.put("bearing", location.getBearing());
      json.put("accuracy", location.getAccuracy());
      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
        json.put("verticalAccuracy", location.getVerticalAccuracyMeters());
      }
      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
        json.put("speedAccuracy", location.getSpeedAccuracyMetersPerSecond());
      }
      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
        json.put("bearingAccuracy", location.getBearingAccuracyDegrees());
      }
      json.put("nanos", location.getElapsedRealtimeNanos());
      json.put("provider", location.getProvider());
      return json;
    } else {
      return null;
    }
  }

  public JSObject getIdleTimeExceededResponse(Intent intent) {
    String session = intent.getStringExtra(LocationService.INTENT_LOCATION_IDLE_TIME_EXCEEDED_EXTRA_SESSION);
    int timeExceeded = intent.getIntExtra(LocationService.INTENT_LOCATION_IDLE_TIME_EXCEEDED_EXTRA_TIME, -1);
    JSObject json = new JSObject();
    json.put("sessionToken", session);
    json.put("timeExceeded", timeExceeded);
    return json;
  }
}
