package de.infa.plugins.bgloc.service.configuration;

import com.google.android.gms.location.LocationRequest;

public class ServiceConfiguration {
  private long mInterval;
  private Long mFastestInterval;
  private Float mSmallestDisplacement;
  private int mPriority;
  private Long mExpiration;

  public ServiceConfiguration() {
    mFastestInterval = null;
    mSmallestDisplacement = null;
    mPriority = LocationRequest.PRIORITY_HIGH_ACCURACY;
    mExpiration = null;
  }

  public long getInterval() { return mInterval; }
  public void setInterval(long value) { mInterval = value; }
  public boolean hasFastestInterval() { return mFastestInterval != null; }
  public Long getFastestInterval() { return mFastestInterval; }
  public void setFastestInterval(long value) { mFastestInterval = value; }
  public boolean hasSmallestDisplacement() { return mSmallestDisplacement != null; }
  public Float getSmallestDisplacement() { return mSmallestDisplacement; }
  public void setSmallestDisplacement(float value) { mSmallestDisplacement = value; }
  public int getPriority() { return mPriority; }
  public void setPriority(int value) { mPriority = value; }
  public boolean hasExpiration() { return mExpiration != null; }
  public Long getExpiration() { return mExpiration; }
  public void setExpiration(long value) { mExpiration = value; }

  public LocationRequest toLocationRequest() {
    LocationRequest request = LocationRequest.create()
      .setInterval(getInterval())
      .setPriority(getPriority());

    if (hasFastestInterval()) {
      request.setFastestInterval(getFastestInterval());
    }
    if (hasSmallestDisplacement()) {
      request.setSmallestDisplacement(getSmallestDisplacement());
    }
    if (hasExpiration()) {
      request.setExpirationDuration(getExpiration());
    }

    return request;
  }
}
