package de.infa.plugins.bgloc.service.storage;

import android.database.Cursor;

import com.getcapacitor.JSObject;

import org.jetbrains.annotations.NotNull;

public class SQLiteJSObjectReader extends SQLiteObjectReader<JSObject> {
  @Override
  public JSObject createFrom(@NotNull Cursor cursor) {
    JSObject obj = new JSObject();
    obj.put("id", cursor.getInt(0));
    obj.put("provider", cursor.getString(15));
    if (!cursor.isNull(1)) {
      obj.put("sessionToken", cursor.getString(1));
    }
    if (!cursor.isNull(2)) {
      obj.put("apiTransmissionFlag", cursor.getInt(2) != 0);
    }
    if (!cursor.isNull(3)) {
      obj.put("appTransmissionFlag", cursor.getInt(3) != 0);
    }
    obj.put("time", cursor.getLong(4));
    obj.put("latitude", cursor.getFloat(5));
    obj.put("longitude", cursor.getFloat(6));
    if (!cursor.isNull(7)) {
      obj.put("altitude", cursor.getFloat(7));
    }
    if (!cursor.isNull(8)) {
      obj.put("speed", cursor.getFloat(8));
    }
    if (!cursor.isNull(9)) {
      obj.put("bearing", cursor.getFloat(9));
    }
    if (!cursor.isNull(10)) {
      obj.put("accuracy", cursor.getFloat(10));
    }
    if (!cursor.isNull(11)) {
      obj.put("verticalAccuracy", cursor.getFloat(11));
    }
    if (!cursor.isNull(12)) {
      obj.put("speedAccuracy", cursor.getFloat(12));
    }
    if (!cursor.isNull(13)) {
      obj.put("bearingAccuracy", cursor.getFloat(13));
    }
    if (!cursor.isNull(14)) {
      obj.put("nanos", cursor.getLong(14));
    }
    return obj;
  }
}
