import { ListenerCallback, PermissionState } from '@capacitor/core';
import { PluginListenerHandle } from '@capacitor/core';
import { Observable } from 'rxjs';
import { InfaBgLocationArray, InfaBgLocationCount, InfaBgLocCleanupByIdsOptions, InfaBgLocCleanupSessionOptions, InfaBgLocConfig, InfaBgLocConfirmReceptionOptions, InfaBgLocFetchOptions, InfaBgLocSessionConfig } from './models/interfaces';
export interface PermissionStatus {
    location: PermissionState;
}
export interface BgLocPlugin {
    echo(options: {
        value: string;
    }): Promise<{
        value: string;
    }>;
    checkPermissions(): Promise<PermissionStatus>;
    requestPermissions(): Promise<PermissionStatus>;
    start(config: InfaBgLocConfig): Promise<void>;
    stop(): Promise<void>;
    getLocations(options: InfaBgLocFetchOptions): Promise<InfaBgLocationArray>;
    getStoredLocationsCount(): Promise<InfaBgLocationCount>;
    getAll(): Promise<InfaBgLocationArray>;
    confirmReception(options: InfaBgLocConfirmReceptionOptions): Promise<void>;
    upload(config: InfaBgLocSessionConfig): Promise<void>;
    cleanup(options?: InfaBgLocCleanupSessionOptions | InfaBgLocCleanupByIdsOptions): Promise<void>;
    addListener(eventName: string, listenerFunc: ListenerCallback): Promise<PluginListenerHandle> & PluginListenerHandle;
    on(eventName: string): Observable<any>;
}
declare const BgLoc: BgLocPlugin;
export default BgLoc;
