import { ListenerCallback, PluginListenerHandle, WebPlugin } from '@capacitor/core';
import { BgLocPlugin, PermissionStatus } from './definitions';
import { Observable } from 'rxjs';
import { InfaBgLocationArray, InfaBgLocationCount, InfaBgLocCleanupByIdsOptions, InfaBgLocCleanupSessionOptions, InfaBgLocConfig, InfaBgLocConfirmReceptionOptions, InfaBgLocFetchOptions, InfaBgLocSessionConfig } from './models/interfaces';
export declare class BgLocWeb extends WebPlugin implements BgLocPlugin {
    private static timer?;
    private static lastId;
    private static records;
    private static location;
    checkPermissions(): Promise<PermissionStatus>;
    requestPermissions(): Promise<PermissionStatus>;
    start(config: InfaBgLocConfig): Promise<void>;
    stop(): Promise<void>;
    getLocations(options: InfaBgLocFetchOptions): Promise<InfaBgLocationArray>;
    getStoredLocationsCount(): Promise<InfaBgLocationCount>;
    getAll(): Promise<InfaBgLocationArray>;
    confirmReception(options: InfaBgLocConfirmReceptionOptions): Promise<void>;
    upload(config: InfaBgLocSessionConfig): Promise<void>;
    cleanup(options?: InfaBgLocCleanupSessionOptions | InfaBgLocCleanupByIdsOptions): Promise<void>;
    addListener(eventName: string, listenerFunc: ListenerCallback): Promise<PluginListenerHandle> & PluginListenerHandle;
    on(eventName: string): Observable<any>;
    echo(options: {
        value: string;
    }): Promise<{
        value: string;
    }>;
}
